

       /*
DEVELOPING GAME IN JAVA 

Caracteristiques

Editeur : NEW RIDERS 
Auteur : BRACKEEN 
Parution : 09 2003 
Pages : 972 
Isbn : 1-59273-005-1 
Reliure : Paperback 
Disponibilite : Disponible a la librairie 
*/

import javax.sound.midi.MidiDevice;
import javax.sound.midi.MidiMessage;
import javax.sound.midi.MidiSystem;
import javax.sound.midi.MidiUnavailableException;
import javax.sound.midi.Receiver;
import javax.sound.midi.Transmitter;
import javax.sound.midi.MidiDevice.Info;

public class Piano
{
	MidiDevice md;
	MidiDevice.Info[]	aInfos;
	
	//MidiDevice md = MidiSystem.getMidiDevice(m[Integer.parseInt(args[0])]);
	
	Transmitter tr ;
	
	int note;
	int push;
	int cosa ;
	boolean[] used;
	
	boolean[] pressed;
	protected final int numnotes=25;
	
		
	public Piano(){
		pressed = new boolean[numnotes];
		used = new boolean[numnotes];
	}
	public boolean getPressed(int i){
		
		return pressed[i];
	}
	public void setPressed(int i,boolean b){
		try{
			pressed[i] = b;
		}
		catch(Exception e){
			//nota no válida
		}
	}
	
	public class Receptor implements Receiver
	{

		public void close()
		{
		
		}

		public void send(MidiMessage message, long timeStamp)
		{
			boolean press=false;
			int note;
			
			int i=0;
			for (byte b: message.getMessage())
			{
				
				if (i==0){
					push = b;
					//System.out.println(push);
					if (push ==-112){
						push =1;
						press = true;
					}
					else if (push ==-128){
						push =0;
						press = false;
					}
					
				}
				if (i==1){
			
					note = b;
					try{
						pressed[note-60] = press;
						used[note-60] = false;
						
					}
					catch(Exception e){
						System.out.println("Error piano.send array pressed excedido" +e);
					}
					
				}
				
				i++;
			}
		
		}

	}
	public int note2key(){
		
		int key = -1;
		switch(note){
		
			case 48: key =0 ;
					break;
			case 50: key =1 ;
			break;
			case 52: key =2 ;
			break;
			case 53: key =3 ;
			break;
			case 55: key =4 ;
			break;
			case 57: key = 5;
			break;
			case 59: key = 6;
			break;
			case 60: key = 7;
			break;
			case 62: key = 8;
			break;
			case 64: key = 9;
			break;
			case 65: key = 10;
			break;
			case 67: key =11 ;
			break;
			case 69: key = 12;
			break;
			case 71: key = 13;
			break;
			case 72: key = 14;
			break;
			
		}

		return key;
		
	}
	
	public int noteblack2key(){
		
		int key = -1;
		switch(note){
		
			case 49: key =0 ;
					break;
			case 51: key =1 ;
			break;
			case 54: key =3 ;
			break;
			case 56: key =4 ;
			break;
			case 58: key =5 ;
			break;
			case 61: key = 7;
			break;
			case 63: key = 8;
			break;
			case 66: key = 10;
			break;
			case 68: key = 11;
			break;
			case 70: key = 12;
			break;

		}

		return key;
		
	}
	/**
	 * @param args
	 */
	public void getdevices(){
		
		Info [] info ;
		info = MidiSystem.getMidiDeviceInfo();
		
		for (int i = 0; i < info.length; i++)
		{
			System.out.println(info[i].getName());
			//System.out.println(m[i].getDescription());
			//System.out.println(m[i].getVersion());
			
		}
		
	}
	public void setUsed(int i,boolean b){
		try{
			used[i] = b;
		}
		catch(Exception e){
			//nota no válida;
		}
	}
	public boolean isUsed(int i){
		return used[i];
	}

	public int getnote() throws InterruptedException{
		
		return this.note;
		
	}
	public int getnoteblack() throws InterruptedException{
		
		return this.noteblack2key();

	}
	public int getpush(){
		
		return push;
	}
	public void start() throws MidiUnavailableException{
		md.open();
	}
	public void init () throws Exception
	{
		//used = false;
		Info [] m = MidiSystem.getMidiDeviceInfo();
		
		
		for (int i = 0; i < m.length; i++)
		{
			System.out.println(m[i].getName());
			//System.out.println(m[i].getDescription());
			//System.out.println(m[i].getVersion());
			
		}
		
		aInfos = MidiSystem.getMidiDeviceInfo();
		
		//MidiDevice md = MidiSystem.getMidiDevice(m[Integer.parseInt(args[0])]);
		md = MidiSystem.getMidiDevice(aInfos[1]);
		tr = md.getTransmitter();
		tr.setReceiver(new Receptor());
		
		//md.open();
		/*
		Object o = new Object();
		synchronized(o)
		{
			o.wait();
		}
		*/
		
	}

}
           